initServices();
initBMService();

var BookmarksCommandMemotoo = 
{
  doBookmarksCommand: function (aSource, aCommand, aArgumentsArray)
  {
    var rCommand = RDF.GetResource(aCommand);
  
    var kSuppArrayContractID = "@mozilla.org/supports-array;1";
    var kSuppArrayIID = Components.interfaces.nsISupportsArray;
    var sourcesArray = Components.classes[kSuppArrayContractID].createInstance(kSuppArrayIID);
    if (aSource) {
      sourcesArray.AppendElement(aSource);
    }
  
    var argsArray = Components.classes[kSuppArrayContractID].createInstance(kSuppArrayIID);
    var length = aArgumentsArray?aArgumentsArray.length:0;
    for (var i = 0; i < length; ++i) {
      var rArc = RDF.GetResource(aArgumentsArray[i].property);
      argsArray.AppendElement(rArc);
      var rValue = null;
      if ("resource" in aArgumentsArray[i]) { 
        rValue = RDF.GetResource(aArgumentsArray[i].resource);
      }
      else
        rValue = RDF.GetLiteral(aArgumentsArray[i].literal);
      argsArray.AppendElement(rValue);
    }

    // Exec the command in the Bookmarks datasource. 
    BMDS.DoCommand(sourcesArray, rCommand, argsArray);
  },

  importBookmarksFromFile: function (aDossier, aFile)
  {
    var rTarget = RDF.GetResource(aDossier);

    if (! BMSVC.isBookmarkedResource(rTarget)) {
    	rTarget = RDF.GetResource("NC:BookmarksRoot");
  	}

    RDFC.Init(BMDS, rTarget);

  	if (versionFirefox()>="1.5")
  	{
  		var countBefore = parseInt(BookmarksUtils.getProperty(rTarget, gRDF_NS+"nextVal"));
  		var args = [{ property: gNC_NS+"URL", literal: aFile}];
    	this.doBookmarksCommand(rTarget, gNC_NS_CMD+"import", args);
    	var countAfter = parseInt(BookmarksUtils.getProperty(rTarget, gRDF_NS+"nextVal"));
  	}
  	else
  	{
    	var countBefore = parseInt(BookmarksUtils.getProperty(rTarget, RDF_NS+"nextVal"));
    	var args = [{ property: NC_NS+"URL", literal: aFile}];
    	this.doBookmarksCommand(rTarget, NC_NS_CMD+"import", args);
    	var countAfter = parseInt(BookmarksUtils.getProperty(rTarget, RDF_NS+"nextVal"));
  	}
/*
    var transaction = new BookmarkImportTransaction("import");
    for (var index = countBefore; index < countAfter; index++) {
      var nChildArc = RDFCU.IndexToOrdinalResource(index);
      var rChild    = BMDS.GetTarget(rTarget, nChildArc, true);
      transaction.item   .push(rChild);
      transaction.parent .push(rTarget);
      transaction.index  .push(index);
    }
    BMSVC.transactionManager.doTransaction(transaction);
    BookmarksUtils.flushDataSource();
*/    
    if (countBefore==countAfter)
    	return false;
  	else
  		return true;
  },
}